3 . git-sh-setup || die "Not a git archive"
5 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
6 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
11 while case "$#" in 0) break ;; esac
14 -a|--a|--ap|--app|--appe|--appen|--append)
17 -f|--f|--fo|--for|--forc|--force)
20 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
21 --update-he|--update-hea|--update-head|--update-head-|\
22 --update-head-o|--update-head-ok)
34 test -f "$GIT_DIR/branches/origin" ||
35 test -f "$GIT_DIR/remotes/origin" ||
36 die "Where do you want to fetch from today?"
41 remote=$(get_remote_url "$@")
44 rsync_slurped_objects=
46 if test "" = "$append"
48 : >$GIT_DIR/FETCH_HEAD
51 append_fetch_head () {
58 # remote-nick is the URL given on the command line (or a shorthand)
59 # remote-name is the $GIT_DIR relative refs/ path we computed
61 case "$remote_name_" in
65 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
66 note_="branch '$note_' of " ;;
68 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
69 note_="tag '$note_' of " ;;
71 note_="$remote_name of " ;;
73 remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
75 note_="$note_$remote_"
77 # 2.6.11-tree tag would not be happy to be fed to resolve.
78 if git-cat-file commit "$head_" >/dev/null 2>&1
80 headc_=$(git-rev-parse --verify "$head_^0") || exit
81 echo "$headc_ $note_" >>$GIT_DIR/FETCH_HEAD
82 echo >&2 "* committish: $head_"
85 echo >&2 "* non-commit: $head_"
88 if test "$local_name_" != ""
90 # We are storing the head locally. Make sure that it is
91 # a fast forward (aka "reverse push").
92 fast_forward_local "$local_name_" "$head_" "$note_"
96 fast_forward_local () {
97 mkdir -p "$(dirname "$GIT_DIR/$1")"
100 # Tags need not be pointing at commits so there
101 # is no way to guarantee "fast-forward" anyway.
102 if test -f "$GIT_DIR/$1"
104 echo >&2 "* $1: updating with $3"
106 echo >&2 "* $1: storing $3"
108 echo "$2" >"$GIT_DIR/$1" ;;
111 # NEEDSWORK: use the same cmpxchg protocol here.
112 echo "$2" >"$GIT_DIR/$1.lock"
113 if test -f "$GIT_DIR/$1"
115 local=$(git-rev-parse --verify "$1^0") &&
116 mb=$(git-merge-base "$local" "$2") &&
119 echo >&2 "* $1: same as $3"
122 echo >&2 "* $1: fast forward to $3"
128 echo >&2 "* $1: does not fast forward to $3;"
129 case "$force,$single_force" in
131 echo >&2 " forcing update."
134 mv "$GIT_DIR/$1.lock" "$GIT_DIR/$1.remote"
135 echo >&2 " leaving it in '$1.remote'"
140 echo >&2 "* $1: storing $3"
142 test -f "$GIT_DIR/$1.lock" &&
143 mv "$GIT_DIR/$1.lock" "$GIT_DIR/$1"
148 case "$update_head_ok" in
150 orig_head=$(cat "$GIT_DIR/HEAD" 2>/dev/null)
154 for ref in $(get_remote_refs_for_fetch "$@")
158 # These are relative path from $GIT_DIR, typically starting at refs/
160 if expr "$ref" : '\+' >/dev/null
163 ref=$(expr "$ref" : '\+\(.*\)')
167 remote_name=$(expr "$ref" : '\([^:]*\):')
168 local_name=$(expr "$ref" : '[^:]*:\(.*\)')
170 rref="$rref $remote_name"
172 # There are transports that can fetch only one head at a time...
174 http://* | https://*)
175 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
178 head=$(curl -nsf $curl_extra_args "$remote/$remote_name") &&
179 expr "$head" : "$_x40\$" >/dev/null ||
180 die "Failed to fetch $remote_name from $remote"
181 echo Fetching "$remote_name from $remote" using http
182 git-http-fetch -v -a "$head" "$remote/" || exit
185 TMP_HEAD="$GIT_DIR/TMP_HEAD"
186 rsync -L "$remote/$remote_name" "$TMP_HEAD" || exit 1
187 head=$(git-rev-parse TMP_HEAD)
189 test "$rsync_slurped_objects" || {
190 rsync -avz --ignore-existing "$remote/objects/" \
191 "$GIT_OBJECT_DIRECTORY/" || exit
192 rsync_slurped_objects=t
196 # We will do git native transport with just one call later.
200 append_fetch_head "$head" "$remote" "$remote_name" "$remote_nick" "$local_name"
205 http://* | https://* | rsync://* )
206 ;; # we are already done.
209 git-fetch-pack "$remote" $rref || echo failed "$remote"
211 while read sha1 remote_name
215 echo >&2 "Fetch failure: $remote"
233 local_name=$(expr "$found" : '[^:]*:\(.*\)')
234 append_fetch_head "$sha1" "$remote" "$remote_name" "$remote_nick" "$local_name"
239 # If the original head was empty (i.e. no "master" yet), or
240 # if we were told not to worry, we do not have to check.
241 case ",$update_head_ok,$orig_head," in
245 curr_head=$(cat "$GIT_DIR/HEAD" 2>/dev/null)
246 if test "$curr_head" != "$orig_head"
248 echo "$orig_head" >$GIT_DIR/HEAD
249 die "Cannot fetch into the current branch."